{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

{
  This units demonstrates the use of tExpression
  in implementing simple expression evaluator
}

unit Unit1;
{$I ..\alldemo.inc}

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,StdCtrls, ExtCtrls,
  PARSEH, EXPROBJ, BASEOP;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    LabelResult: TLabel;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    Expr: tExpression;
    ListRoot: pexProcRec;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses ExprBldr;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  RegisterBaseOpNEXT(ListRoot);
  Expr := tExpression.Create;
end;
procedure TForm1.FormDestroy(Sender: TObject);
begin
  Expr.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  application.terminate;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Expr.SetText(Edit1.Text,ListRoot);
  Try
    Expr.CheckExecute;
    labelresult.caption := Expr.AsString
  Except
    labelresult.caption := '';
    raise
  end;
end;


procedure TForm1.Button3Click(Sender: TObject);
var s: string;
begin
  s := edit1.text;
  if _BuildExpr(s,Listroot,[ext_Null..ext_Bool],@InvokeBuilderHelp) then
    edit1.text := s;
end;

end.
