{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

unit Olesupp;
{$I ..\alldemo.inc}

interface
Uses Windows,Ole2,SysUtils;


{ Some support routines copy/pasted from OLEAUTO }
function ClassIDToString(const ClassID: TCLSID): string;
procedure CreateRegKey(const Key, Value: string);
procedure DeleteRegKey(const Key: string);
function GetServerKey(IsDll: Boolean): string;

implementation


{ Convert a class ID to a string }

function ClassIDToString(const ClassID: TCLSID): string;
var
  P: PWideChar;
begin
  StringFromCLSID(ClassID, P);
  Result := WideCharToString(P);
  CoTaskMemFree(P);
end;

{ Create registry key }

procedure CreateRegKey(const Key, Value: string);
begin
  RegSetValue(HKEY_CLASSES_ROOT, PChar(Key), REG_SZ, PChar(Value),
    Length(Value));
end;

{ Delete registry key }

procedure DeleteRegKey(const Key: string);
begin
  RegDeleteKey(HKEY_CLASSES_ROOT, PChar(Key));
end;

{ Get server key name }

function GetServerKey(IsDll: Boolean): string;
begin
  if IsDll then
    Result := 'InprocServer32' else
    Result := 'LocalServer32';
end;

end.
